/*
  500000ANZXLOEz}V

            2002/ 6/24 ˁ@P
*/

#include <windows.h>
#include "classes.h"

#define IDM_NEXT 0
#define IDM_EXIT 1

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);

HINSTANCE hInst;
HWND hwMain,hwEdit,hwNext;
HMENU hMenu,hMenuFile;
CVm *pvmVm;

void drawState() {

	LPTSTR lpszStr=new TCHAR[4096];
	LPTSTR lpszTmp=new TCHAR[256];

	CVCPU *pcpCpu=pvmVm->getCpu();
	I32 i,j;

	lpszStr[0]=0;

	for (i=0;i<4;i++) {

		wsprintf(lpszTmp,"R%d=%08x ",i,pcpCpu->getRegister(i));
		lstrcat(lpszStr,lpszTmp);

	}

	lstrcat(lpszStr,"\r\n");

	for (i=4;i<8;i++) {

		wsprintf(lpszTmp,"R%d=%08x ",i,pcpCpu->getRegister(i));
		lstrcat(lpszStr,lpszTmp);

	}

	wsprintf(lpszTmp,"\r\nPC=%08lx ",pcpCpu->getPC());
	lstrcat(lpszStr,lpszTmp);

	for (i=0;i<16;i++) {

		wsprintf(lpszTmp,"\r\n%08lx:",i*16);
		lstrcat(lpszStr,lpszTmp);

		for (j=0;j<16;j++) {

			wsprintf(lpszTmp," %02x ",pvmVm->getMemory()->read8(i*16+j));

			lstrcat(lpszStr,lpszTmp);

		}

	}

	SetWindowText(hwEdit,lpszStr);

	delete lpszStr;

}

int WINAPI WinMain (HINSTANCE hInstance,HINSTANCE hPrevInstance,
                    PSTR szCmdLine,int iCmdShow){

	MSG  msg;
	WNDCLASS wndclass;

	hInst=hInstance; /* vZX̃nhۑ */

	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(NULL,IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "CWindow";

	RegisterClass(&wndclass);

	hwMain=CreateWindow("CWindow","z}V",WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU,
             CW_USEDEFAULT,CW_USEDEFAULT,680,550,NULL,NULL,hInstance,NULL);

	/* j[쐬 */
	hMenu=CreateMenu();
	hMenuFile=CreateMenu();
	AppendMenu(hMenuFile,MF_STRING,IDM_EXIT,"I(&Xj");
	AppendMenu(hMenu,MF_POPUP,(UINT)hMenuFile,"t@Ci&Fj");

	/* EChEɃj[ݒ */
	SetMenu(hwMain,hMenu);

	ShowWindow(hwMain,iCmdShow); /* EChE\ */
	UpdateWindow(hwMain);        /* ĕ` */

	while (GetMessage(&msg,NULL,0,0)) { /* bZ[W[v */

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	return msg.wParam ;

}

LRESULT CALLBACK WndProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	switch (iMsg) {

	case WM_CREATE:

		pvmVm=new CVm();

		hwNext=CreateWindow("BUTTON","is",WS_CHILD|WS_VISIBLE|WS_TABSTOP,
		  160,4,72,28,hwnd,(HMENU)IDM_NEXT,hInst,NULL);

		hwEdit=CreateWindow("EDIT",NULL,WS_CHILD|WS_VISIBLE|WS_BORDER|ES_MULTILINE|ES_AUTOVSCROLL|ES_READONLY|WS_TABSTOP,
		  4,40,640,400,hwnd,(HMENU)3,hInst,NULL);

		drawState();

		return 0;

	case WM_COMMAND:

		switch(LOWORD(wParam)) {

		case IDM_NEXT:

			pvmVm->step();
			drawState();

			break;

		case IDM_EXIT:

			DestroyWindow(hwnd);

			break;

		}

		return 0;

	case WM_DESTROY :

		delete pvmVm;

		PostQuitMessage(0);
		return 0;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

